// 
//
// IwGame - Cross Platform Multi-purpose Game Engine using the Marmalade SDK
//
// Developed by Matthew Hopwood of Pocketeers Limited - www.pocketeers.co.uk
//
// For updates, tutorials and more details check out my blog at www.drmop.com
//
// This code is provided free of charge and without any warranty whatsoever. The only restriction to its usage is that this header must remain intact and visible in all IwGame engine files.
// If you use this engine in your product, whilst it is not mandatory, a mention of the IwGame engine would be nice or a quick email to let us know where it is being used.
//
//

#include "IwGameXoml.h"
#include "IwGameUtil.h"
#include "IwGameString.h"
#include "IwGame.h"
#include "IwGameScene.h"
#include "IwGameActor.h"
#include "IwGameAnim.h"
#include "IwGameShapes.h"
#include "IwGameBox2d.h"


unsigned int CIwGameXomlNames::Game_Hash					= CIwGameString::CalculateHash("game");
unsigned int CIwGameXomlNames::Scene_Hash					= CIwGameString::CalculateHash("scene");
unsigned int CIwGameXomlNames::Actor_Hash					= CIwGameString::CalculateHash("actor");
unsigned int CIwGameXomlNames::ActorImage_Hash				= CIwGameString::CalculateHash("actorimage");
unsigned int CIwGameXomlNames::ResourceGroup_Hash			= CIwGameString::CalculateHash("resourcegroup");
unsigned int CIwGameXomlNames::Animation_Hash				= CIwGameString::CalculateHash("animation");
unsigned int CIwGameXomlNames::Box2dMaterial_Hash			= CIwGameString::CalculateHash("box2dmaterial");
unsigned int CIwGameXomlNames::Shape_Hash					= CIwGameString::CalculateHash("shape");

unsigned int CIwGameXomlNames::Name_Hash					= CIwGameString::CalculateHash("name");
unsigned int CIwGameXomlNames::Current_Hash					= CIwGameString::CalculateHash("current");
unsigned int CIwGameXomlNames::CanvasSize_Hash				= CIwGameString::CalculateHash("canvassize");
unsigned int CIwGameXomlNames::FixAspect_Hash				= CIwGameString::CalculateHash("fixaspect");
unsigned int CIwGameXomlNames::LockWidth_Hash				= CIwGameString::CalculateHash("lockwidth");
unsigned int CIwGameXomlNames::Extents_Hash					= CIwGameString::CalculateHash("extents");
unsigned int CIwGameXomlNames::AllowSuspend_Hash			= CIwGameString::CalculateHash("allowsuspend");
unsigned int CIwGameXomlNames::Clipping_Hash				= CIwGameString::CalculateHash("clipping");
unsigned int CIwGameXomlNames::Active_Hash					= CIwGameString::CalculateHash("active");
unsigned int CIwGameXomlNames::Visible_Hash					= CIwGameString::CalculateHash("visible");
unsigned int CIwGameXomlNames::Layers_Hash					= CIwGameString::CalculateHash("layers");
unsigned int CIwGameXomlNames::Colliders_Hash				= CIwGameString::CalculateHash("colliders");
unsigned int CIwGameXomlNames::Type_Hash					= CIwGameString::CalculateHash("type");
unsigned int CIwGameXomlNames::Position_Hash				= CIwGameString::CalculateHash("position");
unsigned int CIwGameXomlNames::Velocity_Hash				= CIwGameString::CalculateHash("velocity");
unsigned int CIwGameXomlNames::VelocityDamping_Hash			= CIwGameString::CalculateHash("velocitydamping");
unsigned int CIwGameXomlNames::Angle_Hash					= CIwGameString::CalculateHash("angle");
unsigned int CIwGameXomlNames::AngularVelocity_Hash			= CIwGameString::CalculateHash("angularvelocity");
unsigned int CIwGameXomlNames::AngularVelocityDamping_Hash	= CIwGameString::CalculateHash("angularvelocitydamping");
unsigned int CIwGameXomlNames::Scale_Hash					= CIwGameString::CalculateHash("scale");
unsigned int CIwGameXomlNames::Colour_Hash					= CIwGameString::CalculateHash("colour");
unsigned int CIwGameXomlNames::Layer_Hash					= CIwGameString::CalculateHash("layer");
unsigned int CIwGameXomlNames::Collidable_Hash				= CIwGameString::CalculateHash("collidable");
unsigned int CIwGameXomlNames::CollisionSize_Hash			= CIwGameString::CalculateHash("collisionsize");
unsigned int CIwGameXomlNames::CollisionRect_Hash			= CIwGameString::CalculateHash("collisionrect");
unsigned int CIwGameXomlNames::WrapPosition_Hash			= CIwGameString::CalculateHash("wrapposition");
unsigned int CIwGameXomlNames::Image_Hash					= CIwGameString::CalculateHash("image");
unsigned int CIwGameXomlNames::Size_Hash					= CIwGameString::CalculateHash("size");
unsigned int CIwGameXomlNames::GroupFile_Hash				= CIwGameString::CalculateHash("groupfile");
unsigned int CIwGameXomlNames::Frame_Hash					= CIwGameString::CalculateHash("frame");
unsigned int CIwGameXomlNames::Value_Hash					= CIwGameString::CalculateHash("value");
unsigned int CIwGameXomlNames::Time_Hash					= CIwGameString::CalculateHash("time");
unsigned int CIwGameXomlNames::Repeat_Hash					= CIwGameString::CalculateHash("repeat");
unsigned int CIwGameXomlNames::Duration_Hash				= CIwGameString::CalculateHash("duration");
unsigned int CIwGameXomlNames::SrcRect_Hash					= CIwGameString::CalculateHash("srcrect");
unsigned int CIwGameXomlNames::Location_Hash				= CIwGameString::CalculateHash("location");
unsigned int CIwGameXomlNames::Resource_Hash				= CIwGameString::CalculateHash("resource");
unsigned int CIwGameXomlNames::Preload_Hash					= CIwGameString::CalculateHash("preload");
unsigned int CIwGameXomlNames::Blocking_Hash				= CIwGameString::CalculateHash("blocking");
unsigned int CIwGameXomlNames::AutoPlay_Hash				= CIwGameString::CalculateHash("autoplay");
unsigned int CIwGameXomlNames::Anim_Hash					= CIwGameString::CalculateHash("anim");
unsigned int CIwGameXomlNames::StartAtTime_Hash				= CIwGameString::CalculateHash("startattime");
unsigned int CIwGameXomlNames::Target_Hash					= CIwGameString::CalculateHash("target");
unsigned int CIwGameXomlNames::Timeline_Hash				= CIwGameString::CalculateHash("timeline");
unsigned int CIwGameXomlNames::Width_Hash					= CIwGameString::CalculateHash("width");
unsigned int CIwGameXomlNames::Height_Hash					= CIwGameString::CalculateHash("height");
unsigned int CIwGameXomlNames::Radius_Hash					= CIwGameString::CalculateHash("radius");
unsigned int CIwGameXomlNames::Points_Hash					= CIwGameString::CalculateHash("points");
unsigned int CIwGameXomlNames::Point_Hash					= CIwGameString::CalculateHash("point");
unsigned int CIwGameXomlNames::Data_Hash					= CIwGameString::CalculateHash("data");
unsigned int CIwGameXomlNames::Density_Hash					= CIwGameString::CalculateHash("density");
unsigned int CIwGameXomlNames::Friction_Hash				= CIwGameString::CalculateHash("friction");
unsigned int CIwGameXomlNames::Restitution_Hash				= CIwGameString::CalculateHash("restitution");
unsigned int CIwGameXomlNames::COM_Hash						= CIwGameString::CalculateHash("com");
unsigned int CIwGameXomlNames::Gravity_Hash					= CIwGameString::CalculateHash("gravity");
unsigned int CIwGameXomlNames::WorldScale_Hash				= CIwGameString::CalculateHash("worldscale");
unsigned int CIwGameXomlNames::Sensor_Hash					= CIwGameString::CalculateHash("sensor");
unsigned int CIwGameXomlNames::CollisionFlags_Hash			= CIwGameString::CalculateHash("collisionflags");

unsigned int CIwGameXomlNames::bool_Hash					= CIwGameString::CalculateHash("bool");
unsigned int CIwGameXomlNames::float_Hash					= CIwGameString::CalculateHash("float");
unsigned int CIwGameXomlNames::vec2_Hash					= CIwGameString::CalculateHash("vec2");
unsigned int CIwGameXomlNames::vec3_Hash					= CIwGameString::CalculateHash("vec3");
unsigned int CIwGameXomlNames::vec4_Hash					= CIwGameString::CalculateHash("vec4");
unsigned int CIwGameXomlNames::rect_Hash					= CIwGameString::CalculateHash("rect");
unsigned int CIwGameXomlNames::string_Hash					= CIwGameString::CalculateHash("string");
unsigned int CIwGameXomlNames::box_Hash						= CIwGameString::CalculateHash("box");
unsigned int CIwGameXomlNames::circle_Hash					= CIwGameString::CalculateHash("circle");
unsigned int CIwGameXomlNames::polygon_Hash					= CIwGameString::CalculateHash("polygon");
unsigned int CIwGameXomlNames::static_Hash					= CIwGameString::CalculateHash("static");
unsigned int CIwGameXomlNames::dynamic_Hash					= CIwGameString::CalculateHash("dynamic");
unsigned int CIwGameXomlNames::kinematic_Hash				= CIwGameString::CalculateHash("kinematic");


//
//
//
//
// CIwGameXomlResourceManager implementation
//
//
//
//
/*void CIwGameXomlResourceManager::addResource(const char* resource_name, const char* resource_filename, bool preload)
{
	IIwGameXomlResource* resource = new CIwGameResourceResource();
	resource->setResourceName(resource_name);
	resource->setResourceFilename(resource_filename);
	Resources.push_back(resource);

	if (preload)
	{
		resource->Load();
	}
}*/

void CIwGameXomlResourceManager::addResource(IIwGameXomlResource *resource)
{
	Resources.push_back(resource);
	resource->setManaged(true);
}

void CIwGameXomlResourceManager::removeResource(IIwGameXomlResource* resource)
{
	removeResource(resource->getNameHash(), resource->getClassTypeHash());
}

void CIwGameXomlResourceManager::removeResource(unsigned int name_hash, unsigned int type_hash)
{
	// Renove named image from the manager
	for (_Iterator it = Resources.begin(); it != Resources.end(); ++it)
	{
		if (name_hash == (*it)->getNameHash() && type_hash == (*it)->getClassTypeHash())
		{
			delete *it;
			Resources.erase(it);
			break;
		}
	}
}

IIwGameXomlResource* CIwGameXomlResourceManager::findResource(unsigned int name_hash, unsigned int type_hash, bool global_search)
{
	// Find and return named image of specific type
	for (_Iterator it = Resources.begin(); it != Resources.end(); ++it)
	{
		if (name_hash == (*it)->getNameHash() && type_hash == (*it)->getClassTypeHash())
			return *it;
	}

	if (global_search)
	{
		// Not found so check global resources
		return IW_GAME_GLOBAL_RESOURCES->getResourceManager()->findResource(name_hash, type_hash, false);
	}

	return NULL;
}

IIwGameXomlResource* CIwGameXomlResourceManager::findResource(const char* name, unsigned int type_hash, bool global_search)
{
	return findResource(CIwGameString::CalculateHash(name), type_hash, global_search);
}

IIwGameXomlResource* CIwGameXomlResourceManager::findResource(const char* name, const char* type, bool global_search)
{
	return findResource(CIwGameString::CalculateHash(name), CIwGameString::CalculateHash(type), global_search);
}


void CIwGameXomlResourceManager::clearResources()
{
	// Remove and delete all images from the manager
	for (_Iterator it = Resources.begin(); it != Resources.end(); ++it)
	{
		delete *it;
	}
	Resources.clear();
}


//
// 
// 
//
// CIwGameXoml Implementation
// 
// 
// 
//
CDECLARE_SINGLETON(CIwGameXoml)

void CIwGameXoml::Init()
{
	// Add some basic classes to the XOML engine
	addClass(new CIwGameCreator());					// CIwGame object
	addClass(new CIwGameResourceGroupCreator());	// CIwGameResourceGroup object 
	addClass(new CIwGameSceneCreator());			// CIwGameScene object 
	addClass(new CIwGameAnimCreator());				// CIwGameAnim object 
	addClass(new CIwGameImageCreator());			// CIwGameImage object 
	addClass(new CIwGameAnimTimelineCreator());		// CIwGameAnimTimeline object 
	addClass(new CIwGameShapeCreator());			// CIwGameShape object 
#if defined(IW_GAME_BOX2D)
	addClass(new CIwGameBox2dMaterialCreator());	// CIwGameBox2dMaterial object 
#endif // IW_GAME_BOX2D_H_

}

void CIwGameXoml::Release()
{
	// Clean up class creators
	for (_Iterator it = begin(); it != end(); ++it)
	{
		delete *it;
	}
	ClassCreators.clear();
}

bool CIwGameXoml::Process(IIwGameXomlResource* parent, const char* filename)
{
	CIwGameXmlParser::PoolsReset();
	CIwGameXmlParser*	xml = new CIwGameXmlParser();

	// Load and parse the xml file
	if (xml->Parse(filename) == eXMLParserError_None)
	{
		// Process the XOML data
		bool error = Process(parent, xml->GetRoot()->GetFirstNode());
		delete xml;
		return error;
	}

	delete xml;
	return false;
}

bool CIwGameXoml::Process(IIwGameXomlResource* parent, CIwGameXmlNode* node)
{
	node->ToLower(true);

	for (CIwGameXmlNode::_Iterator it = node->begin(); it != node->end(); it++)
	{
		unsigned int name_hash = (*it)->GetName().getHash();

		// Check to see if we support the class
		for (_Iterator it2 = begin(); it2 != end(); ++it2)
		{
			if ((*it2)->getClassNameHash() == name_hash)
			{
				// We do support the class so call the classes creator to instantiate it
				IIwGameXomlResource* instance = (*it2)->CreateInstance(parent);
				if (instance != NULL)
				{
					if (!instance->LoadFromXoml(parent, true, *it))
					{
						delete instance;
						CIwGameError::LogError("Error: Near XOML tag ", (*it)->GetName().c_str());
						return false;
					}
				}
				else
				{
					CIwGameError::LogError("Error: No XOML creator present for ", (*it)->GetName().c_str());
					return false;
				}
				break;
			}
		}
	}

	return true;
}

